class ColoredRectangle
     
  def initialize(r, g, b, s1, s2)
    @r, @g, @b, @s1, @s2 = r, g, b, s1, s2
  end

  def ColoredRectangle.whiteRect(s1, s2)
    new(0xff, 0xff, 0xff, s1, s2)
  end
  
  def ColoredRectangle.grayRect(s1, s2)
    new(0x88, 0x88, 0x88, s1, s2)
  end
    
  def ColoredRectangle.coloredSquare(r, g, b, s)
    new(r, g, b, s, s)
  end
     
  def ColoredRectangle.redSquare(s)
    new(0xff, 0, 0, s, s)
  end
     
  def inspect
    "#@r #@g #@b #@s1 #@s2"
  end

end

     
a = ColoredRectangle.new(0x88, 0xaa, 0xff, 20, 30)
b = ColoredRectangle.whiteRect(15,25)
c = ColoredRectangle.redSquare(40)
