class Bank 
  def openSafe 
    # ... 
  end 
  def closeSafe 
    # ... 
  end 

  private :openSafe, :closeSafe 
 
  def makeWithdrawal(amount) 
    if accessAllowed 
      openSafe 
      getCash(amount) 
      closeSafe 
    end
  end 

  # make the rest private 
  private 
 
  def getCash 
    # ... 
  end 
  def accessAllowed 
    # ... 
  end
end 
