module Math
  RAD2DEG = 360.0/(2.0*PI)  # Radians to degrees
  RAD2GRAD = 400.0/(2.0*PI) # Radians to grads
end

def sin_d(theta)
  Math.sin(theta/Math::RAD2DEG)
end

def sin_g(theta)
  Math.sin(theta/Math::RAD2GRAD)
end

def atan2_d(y,x)
  Math.atan2(y,x)/Math::RAD2DEG
end

def atan2_g(y,x)
  Math.atan2(y,x)/Math::RAD2GRAD
end
