def mean(x)
  sum=0
  x.each {|v| sum += v}
  sum/x.size
end

def hmean(x)
  sum=0
  x.each {|v| sum += (1.0/v)}
  x.size/sum
end

def gmean(x)
  prod=1.0
  x.each {|v| prod *= v}
  prod**(1.0/x.size)
end

data = [1.1,2.3,3.3,1.2,4.5,2.1,6.6 ]
am = mean(data)   # 3.014285714
hm = hmean(data)  # 2.101997946
gm = gmean(data)  # 2.508411474

def median(x)
  sorted = x.sort
  mid = x.size/2
  sorted[mid]
end

data =[7,7,7,4,4,5,4,5,7,2,2,3,3,7,3,4 ]
puts median(data)  # 4

def mode(x)
  sorted = x.sort
  a = Array.new
  b = Array.new
  sorted.each do |x|
    if a.index(x)==nil
      a << x # Add to list of values
      b << 1 # Add to list of frequencies
    else
      b[a.index(x)] += 1 # Increment existing counter
    end
  end
  maxval = b.max           # Find highest count
  where = b.index(maxval)  # Find index of highest count
  a[where]                 # Find corresponding data value
end

data =[7,7,7,4,4,5,4,5,7,2,2,3,3,7,3,4 ]
puts mode(data)            # 7
