class PersonalComputer

  attr_accessor :manufacturer,
    :model, :processor, :clock,
    :ram, :disk, :monitor,
    :colors, :vres, :hres, :net

  def initialize(&block)
    instance_eval &block;
  end

  # Other methods...

end

desktop = PersonalComputer.new do
  self.manufacturer = "Acme"
  self.model = "THX-1138"
  self.processor = "986"
  self.clock = 2.4        # GHz
  self.ram = 1024         # Mb
  self.disk = 800         # Gb
  self.monitor = 25       # inches
  self.colors = 16777216
  self.vres = 1280
  self.hres = 1600
  self.net = "T3"
end

p desktop
