require "thread"
 
$music  = Mutex.new
$violin = ConditionVariable.new
$bow    = ConditionVariable.new
 
$violinsFree = 2
$bowsFree    = 1
 
def musician(n)
  loop do
    sleep rand 0
    $music.synchronize do
      $violin.wait($music) while $violinsFree == 0
      $violinsFree -= 1
      puts "#{n} has a violin"
      puts "violins #$violinsFree, bows #$bowsFree"
 
      $bow.wait($music) while $bowsFree == 0
      $bowsFree -= 1
      puts "#{n} has a bow"
      puts "violins #$violinsFree, bows #$bowsFree"
    end
 
    sleep rand 0
    puts "#{n}:  (...playing...)"
    sleep rand 0
    puts "#{n}: Now I've finished."
 
    $music.synchronize do
      $violinsFree += 1
      $violin.signal if $violinsFree == 1
      $bowsFree += 1
      $bow.signal if $bowsFree == 1
    end
  end
end
 
threads = []
3.times do |i|
  threads << Thread.new { musician(i) }
end
 
threads.each {|t| t.join }
